//hdcphu@remove defined function and write full function
// #define BlendScreenf(base, blend) 		(1.0 - ((1.0 - base) * (1.0 - blend)))
// #define Blend(base, blend, funcf) 		vec3(funcf(base.r, blend.r), funcf(base.g, blend.g), funcf(base.b, blend.b))
// #define BlendScreen(base, blend) 		Blend(base, blend, BlendScreenf)

uniform sampler2D diffuseMap;
varying highp vec2 uv1;

#ifndef PAINT_IN_SHADOW
uniform sampler2D screenMap;
uniform sampler2D normalMap;

varying highp vec3 lightDir;

varying highp vec2 uv0;
varying highp vec2 uv2;
#endif

#ifdef USE_ADJUST_SATURATION		
	#include "adjust_saturation.fs"			
#endif

void main()
{
	lowp vec4 alphaColor = texture2D(diffuseMap, uv1);

#ifdef PAINT_IN_SHADOW

	#ifdef USE_ADJUST_SATURATION	
		gl_FragColor = desaturate(vec4(0.10, 0.11, 0.32, alphaColor.a));
	#else
		gl_FragColor = vec4(0.10, 0.11, 0.32, alphaColor.a);
	#endif

#else

	highp float SpecularIntensity = 5.8;
	mediump float Shininess = 4.0;

	lowp vec3 textureComponent = texture2D(diffuseMap, uv0).rgb;
	lowp vec3 screenColor = texture2D(screenMap, uv2).rgb;
	highp vec3 normalValue = texture2D(normalMap, uv2).rgb;

	highp vec3 base = textureComponent + 0.15;
	highp vec3 blend = screenColor - 0.3;
	//hdcphu@remove defined function and write full function
	// textureComponent = BlendScreen(base, blend);	
	textureComponent = vec3((1.0 - ((1.0 - base.r) * (1.0 - blend.r))), (1.0 - ((1.0 - base.g) * (1.0 - blend.g))), (1.0 - ((1.0 - base.b) * (1.0 - blend.b))));

	///normalize
	highp float nx = normalValue.x*2.0 - 1.0;
	highp float ny = -(normalValue.y*2.0 - 1.0);
	highp vec3 fragNormal = vec3(nx, ny, sqrt(1.0 - nx*nx - ny*ny));

	highp float NdotH = max(dot(fragNormal, lightDir), 0.0);
	highp float specComponent = pow( NdotH, Shininess) * SpecularIntensity;


	#ifdef USE_ADJUST_SATURATION	
		gl_FragColor = desaturate(vec4( textureComponent, alphaColor.a ));
	#else
		gl_FragColor = vec4( textureComponent, alphaColor.a );
	#endif

#endif
}
