uniform highp mat4 inWorldViewProjMatrix;
attribute vec3 inPos;

attribute vec2 inUV1;
varying highp vec2 uv1;

#ifndef PAINT_IN_SHADOW
uniform highp mat4 inWorldMatrix;
attribute vec3 inNormal;
attribute vec2 inUV0;
attribute vec2 inUV2;

varying highp vec2 uv0;
varying highp vec2 uv2;
varying highp vec3 lightDir;
#endif

void main()
{
	gl_Position = inWorldViewProjMatrix * vec4(inPos, 1.0);

	uv1 = inUV1;

#ifndef PAINT_IN_SHADOW
	lightDir = normalize(vec3(-1.0, 1.0, 1.0));
	lightDir = vec3(inWorldMatrix * vec4(lightDir, 1.0));

	uv0 = inUV0 * 0.1;
	uv2 = inUV2;
#endif
}
