uniform highp mat4 inWorldViewProjMatrix;
uniform lowp float inAlpha;

attribute vec3 inPos;
attribute vec2 inUV1;
attribute vec2 inUV0;
varying mediump vec2 uv0;
varying mediump vec2 uv1;
varying lowp float alphaVal;

#ifdef USE_SPECULAR
#ifndef PAINT_IN_SHADOW
uniform highp mat4 inWorldMatrix;
attribute vec2 inUV2;

varying highp vec2 uv2;
varying lowp vec3 lightDir;
#endif
#endif //USE_SPECULAR
void main()
{
	gl_Position = inWorldViewProjMatrix * vec4(inPos, 1.0);

	alphaVal = inAlpha;

	uv1 = inUV1;
	uv0 = inUV0;
	
#ifdef USE_SPECULAR
#ifndef PAINT_IN_SHADOW
	lightDir = normalize(vec3(-1.0, 1.0, 1.0));
	lightDir = vec3(inWorldMatrix * vec4(lightDir, 1.0));	
	uv2 = inUV2;
#endif
#endif //USE_SPECULAR
}
