uniform highp mat4 inWorldViewProjMatrix;
attribute vec3 inPos;

#ifndef PAINT_IN_SHADOW
uniform highp vec3 inPLightPos[8];

attribute vec3 inNormal;
attribute vec2 inUV0;
attribute vec2 inUV1;

varying lowp float NdotL;
varying highp vec2 uv0;
varying highp vec2 uv1;
#endif

void main()
{
	gl_Position = inWorldViewProjMatrix * vec4(inPos, 1.0);

#ifndef PAINT_IN_SHADOW

	highp vec3 normal = normalize(inNormal.xyz);
	highp vec3 lightDir = normalize(inPLightPos[0]);
	NdotL = max(dot(normal, lightDir), 0.0);

	uv0 = inUV0 * 0.2;
	uv1 = inUV1;
#endif
}
