#ifdef USE_2D
uniform highp vec3 inProj2DMatrix[2];
#endif

#ifdef USE_3D
uniform mat4 inWorldViewProjMatrix;
#endif


attribute vec3 inPos;

attribute vec2 inUV0;
varying mediump vec2 uv0;

#ifdef USE_VERTEX_COLOR
attribute vec4 inVtxColor;
varying lowp vec4 vtxColor;
#endif

void main()
{
#ifdef USE_2D
	highp vec2 pos = vec2(dot(inProj2DMatrix[0], vec3(inPos.xy, 1.0)),
						  dot(inProj2DMatrix[1], vec3(inPos.xy, 1.0)));

	gl_Position = vec4(pos.x, pos.y, inPos.z, 1.0);
#endif

#ifdef USE_3D
	gl_Position = inWorldViewProjMatrix * vec4(inPos, 1.0);
#endif

	uv0 = inUV0;

#ifdef USE_VERTEX_COLOR
	vtxColor = inVtxColor;
#endif
}
