varying mediump vec2 uv;
uniform sampler2D texture0;
uniform sampler2D texture0alpha;
uniform sampler2D palettesMap;
uniform int inPalette;

void main()
{
	mediump vec4 texColor0 = vec4(texture2D(texture0, uv).xyz, texture2D(texture0alpha, uv).x);
	//0.00390625 conversion from 0->255 to 0.0->1.0. Change it if gradient map size is changed.
	
#ifdef USE_CURVE_CORRECTION	

	highp vec2 texCoors = vec2( texColor0.r * 0.295 + texColor0.g * 0.585 + texColor0.b * 0.105 , float(inPalette) * 0.00390625 + 0.002);
	highp vec4 finalColor = vec4( texture2D(palettesMap, texCoors).rgb, 0.5 * texColor0.a );
	
#else

	highp vec4 finalColor = vec4( texColor0.rgb, 0.4 * texColor0.a );
	
#endif //

#ifdef USE_ADJUST_SATURATION
	gl_FragColor = desaturate(finalColor);
#else
	gl_FragColor = finalColor;
#endif	
}
