#ifdef USE_2D
uniform highp vec3 inProj2DMatrix[2];
uniform highp float inScale;
#endif

#ifdef USE_3D
uniform mat4 inWorldViewProjMatrix;
#endif

attribute vec3 inPos;

#ifdef USE_TEXTURE
attribute vec2 inUV0;
varying mediump vec2 uv;
#endif

void main()
{
#ifdef USE_2D
	highp vec2 pos = vec2(dot(inProj2DMatrix[0], vec3(inScale*inPos.xy, 1.0)),
						  dot(inProj2DMatrix[1], vec3(inScale*inPos.xy, 1.0)));

	gl_Position = vec4(pos.x, pos.y, inPos.z, 1.0);
#endif

#ifdef USE_3D
	gl_Position = inWorldViewProjMatrix * vec4(inPos, 1.0);
#endif

#ifdef USE_TEXTURE
	uv = inUV0;
#endif
}
